//=======================================================================
// devinette.cc : implmentation du jeu "trop petit, trop grand"
// Copyright (C) 2003-2007 by Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//=======================================================================

#include <iostream>             // entre-sortie standard
#include <iomanip>              // manipulateurs pour formater
#include <cstdlib>              // random() et srandom()
#include <ctime>                // pour dclarer time()
using namespace std;            // accs direct aux fonctions standard

int main()
{
  cout << "\nBienvenue au jeu \"trop petit, trop grand\" !" << endl;
  cout << "Entrez un nombre maximal svp : ";
  int max; cin >> max; 
  if ( max < 1 ) return 0;

  srandom( time(NULL) );        // initialiser le gnrateur alatoire
  int secret= random()%max + 1; // produire un nombre alatoire
  cout << "J'ai choisi un nombre secret entre 1 et " << max << "." << endl;

  // La premire boucle laisse l'utilisateur deviner.
  // On sort par return si le nombre secret a t trouv.
  for( int rang=1; ; ++rang )
    {
      int devine; // le nombre devin par l'utilisateur
      
      // La deuxime boucle lit au clavier le nombre devin
      // On sort par break si le nombre est dans la plage correcte.
      // On sort par return si l'utilisateur prfre abandonner.
      for(;;)
	{
	  cout << "Essai" << setw(3) << rang << ", devinez : ";
	  cin >> devine;
	  if ( devine >= 1 && devine <= max ) break;
	  cout << "Voulez-vous abandonner ? (o/n) ";
	  char reponse; cin >> reponse;
	  if ( reponse == 'o' ) return 0;
	}

      // Un fois un nombre a t entr, on teste les trois cas :
      // trouv, trop petit, trop grand
      if ( devine == secret )
	{
	  cout << "Trouv ! Mon nombre vaut " << secret 
	       << ".\nAu revoir.\n" << endl; 
	  return 0;
	};
      if ( devine < secret )
	cout << "Trop petit." << endl;
      else 
	cout << "Trop grand." << endl;
    }
}
