//=======================================================================
// limites.cc : dterminer le min et le max des types entiers en C++
// Copyright (C) 2003-2007 Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//=======================================================================

#include <iostream>   // dclarer l'entre-sortie standard
#include <iomanip>    // manipulateurs pour formater les flots
using namespace std;  // accs direct aux fonctions standard

// Les calculs suivants dterminent les valeurs minimales et maximales
// des types entiers primitifs en C++. On suppose qu'un tel type occupe 
// n bits et ne peut donc contenir que les valeurs  0...2^n-1 (unsigned) 
// ou -2^(n-1)..2^(n-1)-1 (signed). On suppose galement que l'addition et
// la soustraction sont effectues modulo 2^n, sans erreur de dpassement.

const unsigned short     int min_usi  = 0;
const unsigned short     int max_usi  = min_usi-1;
const signed   short     int max_ssi  = max_usi/2;
const signed   short     int min_ssi  = max_ssi+1;

const unsigned           int min_ui   = 0;
const unsigned           int max_ui   = min_ui-1;
const signed             int max_si   = max_ui/2;
const signed             int min_si   = max_si+1;

const unsigned long      int min_uli  = 0;
const unsigned long      int max_uli  = min_uli-1;
const signed   long      int max_sli  = max_uli/2;
const signed   long      int min_sli  = max_sli+1;

const unsigned long long int min_ulli = 0;
const unsigned long long int max_ulli = min_ulli-1;
const signed   long long int max_slli = max_ulli/2;
const signed   long long int min_slli = max_slli+1;

// La fonction main affiche les rsultats ainsi calculs.
int main()
{
  cout << "Voici les capacits des types entiers :" << endl;
  cout << "unsigned short     int : " << setw(3) 
       << 8*sizeof(unsigned short int) << " bits  ==>  valeurs "
       << setw(20) << min_usi << " ... " << setw(20) << max_usi << endl;
  cout << "signed   short     int : " << setw(3) 
       << 8*sizeof(signed short int) << " bits  ==>  valeurs "
       << setw(20) << min_ssi << " ... " << setw(20) << max_ssi << endl;
  cout << "unsigned           int : " << setw(3) 
       << 8*sizeof(unsigned int) << " bits  ==>  valeurs "
       << setw(20) << min_ui<< " ... " << setw(20) << max_ui << endl;
  cout << "signed             int : " << setw(3) 
       << 8*sizeof(signed int) << " bits  ==>  valeurs "
       << setw(20) << min_si << " ... " << setw(20) << max_si << endl;
  cout << "unsigned long      int : " << setw(3) 
       << 8*sizeof(unsigned long int) << " bits  ==>  valeurs "
       << setw(20) << min_uli << " ... " << setw(20) << max_uli << endl;
  cout << "signed   long      int : " << setw(3) 
       << 8*sizeof(signed long int) << " bits  ==>  valeurs "
       << setw(20) << min_sli << " ... " << setw(20) << max_sli << endl;
  cout << "unsigned long long int : " << setw(3) 
       << 8*sizeof(unsigned long long int) << " bits  ==>  valeurs "
       << setw(20) << min_ulli << " ... " << setw(20) << max_ulli << endl;
  cout << "signed   long long int : " << setw(3) 
       << 8*sizeof(signed long long int) << " bits  ==>  valeurs "
       << setw(20) << min_slli << " ... " << setw(20) << max_slli << endl;
}
