#include <iostream>
#include <vector>
using namespace std;
typedef unsigned long long int Integer;

// Calculer  P(a,b) = a^4 + b^4  modulo mod (sans dbordement)
Integer lePolynomeP( Integer a, Integer b, Integer mod )
{ 
  a%=mod; a*=a; a%=mod; a*=a; a%=mod;
  b%=mod; b*=b; b%=mod; b*=b; b%=mod;
  return (a+b) % mod; 
}

// Calculer  Q(c,d) = d^4 - c^4  modulo mod (sans dbordement)
Integer lePolynomeQ( Integer c, Integer d, Integer mod )
{ 
  c%=mod; c*=c; c%=mod; c*=c; c%=mod;
  d%=mod; d*=d; d%=mod; d*=d; d%=mod;
  return ( c<=d ? d-c : d-c+mod ); 
}

// Pour tenir compte des restrictions modulaires, la fonction suivante
// construit un vecteur  image  du type  vector<bool>  et de longueur mod 
// de sorte que  image[x]==true  ssi x est dans l'image de P modulo mod.
vector<bool> imagePmod( const int& mod )
{
  cout << "construction de l'image de P mod " << mod << " ... " << flush;
  vector<bool> image(mod,false);
  for ( int a=0; a<mod; ++a )
    for ( int b=0; b<mod; ++b )
      image[ lePolynomeP(a,b,mod) ]= true;
  cout << "statistique : " << flush;
  Integer possibles=0;
  for ( int c=0; c<mod; ++c )
    for ( int d=0; d<mod; ++d )
      if ( image[ lePolynomeQ(c,d,mod) ] ) ++possibles;
  cout << (100*possibles)/(mod*mod) << "% retenus" << endl;
  return image;
}

// Construction des images modulo 5^4,13^2,3^4,29^2,7^3,11^2,19^2,31^2.
// (Dans l'ordre d'efficacit, d'aprs de nombreux tests empiriques.)
// Les images sont prcalcules comme des vecteurs constants, 
// ce qui permettra d'accder rapidement  ces informations.
const vector<bool>  
  image625= imagePmod(625), image169= imagePmod(169),
  image81 = imagePmod(81),  image841= imagePmod(841), 
  image343= imagePmod(343), image121= imagePmod(121), 
  image361= imagePmod(361), image961= imagePmod(961);

// La fonction  crible(c,d)  teste si le couple (c,d) passe les cribles.
// Si non, elle renvoie false et on peut supprimer (c,d) dans la suite.
bool crible( Integer c, Integer d )
{
  return image625[lePolynomeQ(c,d,625)] && image169[lePolynomeQ(c,d,169)]
      && image81 [lePolynomeQ(c,d,81) ] && image841[lePolynomeQ(c,d,841)]
      && image343[lePolynomeQ(c,d,343)] && image121[lePolynomeQ(c,d,121)] 
      && image361[lePolynomeQ(c,d,361)] && image961[lePolynomeQ(c,d,961)];
}
