class Group
{
private:
  vector<Permut> theGenerators;
  set<Permut>    theElements;

public:
  // Constructeurs
  Group() { theElements.insert( Permut() ); };
  Group( const Permut& p ) { theElements.insert( Permut() ); insert(p); };
  
  // Effacer les donnes et recommencer par le groupe trivial
  void clear( void );
  
  // Accder aux gnrateurs et aux lments du groupe
  const vector<Permut>& generators( void ) const
    { return theGenerators; };
  const set<Permut>& elements( void ) const
    { return theElements; };
  set<Permut>::size_type order( void ) const
    { return theElements.size(); };

  // Tester l'inclusion d'un lment ou d'un sous-groupe
  bool contains( const Permut& p ) const
    { return theElements.find(p) != theElements.end(); }
  bool contains( const Group& g ) const;
  
  // Ajouter des gnrateurs
  void insert( const Permut& p );
  void insert( const set<Permut>& s );
  void insert( const vector<Permut>& v );
  
  // Construire le centre ou des centralisateurs
  bool is_abelian( void ) const;                            // exercice !
  bool centralizes( const Permut& p ) const;                // exercice !
  bool centralizes( const Group& g ) const;                 // exercice !
  Group centre( void ) const;                               // exercice !
  Group centralizer( const Permut& p ) const;               // exercice !
  Group centralizer( const Group& g ) const;                // exercice !
  
  // Construire le normalisateur d'un sous-groupe
  bool normalizes( const Group& g ) const;                  // exercice !
  Group normalizer( const Group& g ) const;                 // exercice !
  
  // Construire des classes de conjugaison
  set<Permut> conj_class( const Permut& p ) const;          // exercice !
  vector< set<Permut> > conj_classes(void) const;           // exercice !
  bool is_simple( Group& dist ) const;                      // exercice !

  // Entre et sortie
  friend ostream& operator << ( ostream& out, const Group& g )
    { g.write( out ); return out; };
  friend istream& operator >> ( istream& in, Group& g )
    { g.read( in ); return in; };

private:
  void write( ostream& out ) const;
  void read( istream& in );
};
