class Permut
{
public:  
  // Trois types de donnes auxiliaires utiliss dans la suite
  typedef short int Point;      // type pour les points  permuter
  typedef vector<Point> Cycle;  // type utilis pour un cycle
  typedef vector<Cycle> Cycles; // type utilis pour une liste de cycles
  
private: 
  // Reprsentation interne d'une permutation
  vector<Point> leVecteur;      // vecteur pour stocker la permutation
  void raccourcir( void );      // supprimer les points fixes  la fin
  void rallonger( Point deg );  // ajouter des points fixes  la fin

  // Opration sur les points (sans contrle de domaine)
  const Point& operator[] ( Point a ) const { return leVecteur[a]; };
  Point& operator[] ( Point a ) { return leVecteur[a]; };

public:
  // Opration sur les points (avec contrle de domaine)
  Point operator () ( Point a ) const 
    { return ( a<0 || a>=leVecteur.size() ? a : leVecteur[a] ); };
  const vector<Point>& vecteur( void ) const { return leVecteur; };

public:
  // Constructeurs divers 
  Permut( const Permut& p )  { leVecteur= p.leVecteur; };
  Permut( Point a, Point b ) { setTransposition(a,b); };
  Permut( const Cycle& c )   { setCycle(c); };
  Permut( const Cycles& c )  { setCycles(c); };
  Permut( const char* s )    { istrstream in(s); in >> *this; };
  Permut( const string& s )  { istrstream in(s.c_str()); in >> *this; };
  
  // Reconnatre l'identit et dterminer le degr 
  bool isIdentity( void ) const { return ( leVecteur.size() == 0 ); };
  Point degre( void ) const     { return leVecteur.size(); };
  
  // Constructions diverses
  void setIdentity( void ) { leVecteur.clear(); };
  void setTransposition( Point a, Point b );
  void setReversion( Point degre );
  void setRandom( Point degre );
  void setCycle( const Cycle& c );
  void setCycles( const Cycles& c );
  void getCycles( Cycles& cycles ) const;
 
  // Loi de groupe: inversion et multiplication
  friend Permut operator ! ( const Permut& p );
  friend Permut operator * ( const Permut& p, const Permut& q );
  
  // Proprits diverses
  long inversions( void ) const;                               // exercice !
  int  signature( void ) const;                                // exercice !
  long ordre( void ) const;                                    // exercice !

  // Oprateurs d'entre-sortie
  friend ostream& operator << ( ostream& out, const Permut& p );
  friend istream& operator >> ( istream& in, Permut& p );
};
