//=======================================================================
// ackermann.cc : calcul de la fonction d'Ackermann
// Copyright (C) 2004-2007 by Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
// 
// Compilation :
//  compiler avec l'option -lgmpxx pour inclure la bibliothque GMP.
//=======================================================================

#include <iostream>
#include <iomanip>
#include <gmpxx.h>
typedef mpz_class Integer;
using namespace std;

Integer ackermann( Integer n, Integer k )
{
  if ( n<0 || k<0 ) return 0;
  if ( n == 0 ) return k+1;
  if ( k == 0 ) return ackermann(n-1,1);
  return ackermann( n-1, ackermann(n,k-1) );
}

int main()
{
  cout << "Les premires valeurs de la fonction d'Ackermann :";
  cout << "\nAckermann(0,k) : " << flush;
  for ( int k=0; k<=8; ++k) 
    cout << setw(5) << ackermann(0,k) << flush; 
  cout << "\nAckermann(1,k) : " << flush;
  for ( int k=0; k<=8; ++k) 
    cout << setw(5) << ackermann(1,k) << flush; 
  cout << "\nAckermann(2,k) : " << flush;
  for ( int k=0; k<=8; ++k) 
    cout << setw(5) << ackermann(2,k) << flush; 
  cout << "\nAckermann(3,k) : " << flush;
  for ( int k=0; k<=8; ++k) 
    cout << setw(5) << ackermann(3,k) << flush; 
  cout << "\nAckermann(4,k) : " << flush;
  for ( int k=0; k<=8; ++k) 
    cout << setw(5) << ackermann(4,k) << flush; 
  cout << "\nAu revoir." << endl;
}
