//=======================================================================
// gauss.cc : l'algorithme de Gauss-Bzout sur les matrices
// Copyright (C) 2007 by Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//
// Description : 
// On implmentera en exercice les fonctions manquantes
//=======================================================================

#include "integer.cc"  // implmenter encore le pgcd
#include "matrix.cc"
using namespace std;

//-----------------------------------------------------------------------
// Opration de la matrice (a,b;c,d)  gauche sur la matrice mat.
// Cette opration ne concerne que les lignes i et j.
// Optimisation: on suppose i < j et que les lignes sont nulles 
// avant la colonne i (comme dans l'algorithme de Gauss-Bzout).
//-----------------------------------------------------------------------
template <typename K>
void gauss_gauche( const K& a, const K& b, const K& c, const K& d,
		   Matrix<K>& mat, const Dim i, const Dim j, const Dim offset=1 )
{
    //
    //  implmenter en exercice (7 lignes environ)
    //
}

//-----------------------------------------------------------------------
// Opration de la matrice (a,b;c,d)  droite sur la matrice mat.
// Cette opration ne concerne que les colonnes i et j.
// Optimisation: on suppose i < j et que les colonnes sont nulles 
// au-dessus de la ligne i (comme dans l'algorithme de Gauss-Bzout).
//-----------------------------------------------------------------------
template <typename K>
void gauss_droite( const K& a, const K& b, const K& c, const K& d,
		   Matrix<K>& mat, const Dim i, const Dim j, const Dim offset=1 )
{
    //
    //  implmenter en exercice (7 lignes environ)
    //
}

//-----------------------------------------------------------------------
// limination de Gauss
//-----------------------------------------------------------------------
template <typename K>
bool gauss_colonne( Matrix<K>& mat, Matrix<K>& s, Dim k )
{
    //
    //  implmenter en exercice (20 lignes environ)
    //
}

template <typename K>
bool gauss_ligne( Matrix<K>& mat, Matrix<K>& t, Dim k )
{
    //
    //  implmenter en exercice (20 lignes environ)
    //
}

template <typename K>
void gauss_bezout( Matrix<K>& mat, Matrix<K>& s, Matrix<K>& t )
{
    //
    //  implmenter en exercice (20 lignes environ)
    //
}

//-----------------------------------------------------------------------
// Matrix alatoire pour des tests
//-----------------------------------------------------------------------
Matrix<Integer> randmat( const Dim n, const Integer& max )
{
    Matrix<Integer> mat(n,n);
    for ( Dim i=1; i<=n; ++i )
	for ( Dim j=2; j<=n; ++j )
	    mat(i,j)= random( -max, +max );
    return mat;
}

//-----------------------------------------------------------------------
// La fonction main() gre la communication avec le monde extrieur
//-----------------------------------------------------------------------
int main()
{
    cout << "\nBonjour et bienvenue chez Gauss-Bzout.\n";
 
    Matrix<Integer> a, d, s, t;

    // Lire une matrice du clavier ou d'un fichier
    cout << "Entrez la matrice  diagonaliser svp :" << endl;
    cin >> a;
    cout << "\nJ'ai lu la matrice suivante :\na =\n" << a << endl;

    // Crer une matrice alatoire
    // a= randmat(10,99);
    // cout << "\nJ'ai cr la matrice suivante :\na =\n" << a << endl;
    
    cout << endl << "J'applique l'algorithme de Gauss-Bzout..." << endl;
    d= a;
    gauss_bezout( d, s, t );

    cout << endl << "Rsultats :" << endl
	 << "d =\n" << d << endl 
	 << "s =\n" << s << endl 
	 << "t =\n" << t << endl;
    cout << "Vrification :" << endl
	 << "s a t =\n" << s * a * t << endl; 
}

