class Anneau
{
public :
  Anneau( int n=0 );                             // constructeur/conversion
  Anneau( const Anneau& source );                // constructeur par copie
  Anneau& operator=  ( int n );                  // affectation/conversion
  Anneau& operator=  ( const Anneau& a );        // affectation par copie
  bool    operator== ( const Anneau& a ) const;  // test d'galit
  bool    operator!= ( const Anneau& a ) const;  // test de diffrence
  Anneau  operator+  ( const Anneau& a ) const;  // addition
  Anneau& operator+= ( const Anneau& a );        // addition en place
  Anneau  operator-  () const;                   // oppos 
  Anneau  operator-  ( const Anneau& a ) const;  // soustraction
  Anneau& operator-= ( const Anneau& a );        // soustraction en place
  Anneau  operator*  ( const Anneau& a ) const;  // multiplication
  Anneau& operator*= ( const Anneau& a );        // multiplication en place
};

// Oprateurs d'entre-sortie
ostream& operator<< ( ostream& out, const Anneau& a );
istream& operator>> ( istream& in, Anneau& a );

// Reconnatre les lments 0 et 1
bool    zero       ( const Anneau& a );
bool    one        ( const Anneau& a );

// Dterminer si a est inversible, si oui calculer son inverse
bool    inversible ( const Anneau& a );
bool    inversible ( const Anneau& a, Anneau& inverse );

// Dterminer si a est divisible par b, si oui calculer le quotient q
bool    divisible  ( const Anneau& a, const Anneau& b );
bool    divisible  ( const Anneau& a, const Anneau& b, Anneau& q );

// Dterminer si a et b sont associs, si oui calculer u tel que ua=b
bool    associes   ( const Anneau& a, const Anneau& b );
bool    associes   ( const Anneau& a, const Anneau& b, Anneau& u );

// Choisir un reprsentant prfr r=ua parmi les lments associs  a
Anneau  assopref   ( const Anneau& a );
Anneau  assopref   ( const Anneau& a, Anneau& u );
