#include <iostream>
#include "integer.cc"
using namespace std;

// La classe Gauss modlisant l'anneau Z[i]
class Gauss
{
public:
  Integer re, im;
  Gauss( const Integer& x=0, const Integer& y=0 ); 
  Gauss( const Gauss& a );
  Gauss& operator=  ( const Gauss& a );
  bool   operator== ( const Gauss& a ) const;
  bool   operator!= ( const Gauss& a ) const;
  Gauss  operator+  ( const Gauss& a ) const;
  Gauss& operator+= ( const Gauss& a );
  Gauss  operator-  () const;
  Gauss  operator-  ( const Gauss& a ) const;
  Gauss& operator-= ( const Gauss& a );
  Gauss  operator*  ( const Gauss& a ) const;
  Gauss& operator*= ( const Gauss& a );
};

// Oprateurs d'entre-sortie
ostream& operator<< ( ostream& out, const Gauss& a );
istream& operator>> ( istream& in, Gauss& a );

// Quelques fonctions supplmentaires
bool    zero ( const Gauss& a );
bool    one  ( const Gauss& a );
Gauss   conj ( const Gauss& a );
Integer norme( const Gauss& a );

// Inversibilit, divisibilit, lments associs
bool  inversible( const Gauss& a );
bool  inversible( const Gauss& a, Gauss& b );
bool  divisible ( const Gauss& a, const Gauss& b );  
bool  divisible ( const Gauss& a, const Gauss& b, Gauss& q );
bool  associes  ( const Gauss& a, const Gauss& b );
bool  associes  ( const Gauss& a, const Gauss& b, Gauss& u );
Gauss assopref  ( const Gauss& a );
Gauss assopref  ( const Gauss& a, Gauss& u );

// Une division euclidienne adapte  la norme
void  eudiv( const Gauss& a, const Gauss& b, Gauss& q, Gauss& r );
Gauss eudiv( const Gauss& a, const Gauss& b );
Gauss eumod( const Gauss& a, const Gauss& b );

// L'algorithme d'Euclide-Bzout
Gauss pgcd( Gauss a, Gauss b, Gauss& u, Gauss& v );
Gauss pgcd( Gauss a, Gauss b, Gauss& u );
Gauss pgcd( Gauss a, Gauss b );
