#include <iostream>
using namespace std;

// Dfinition d'une classe gnrique modlisant un anneau quotient
template <typename Anneau>
class Quot
{
private:
  static Anneau mod;  // le module commun de tous les objets de la classe
  Anneau rep;         // le reprsentant particulier de l'objet courant

public:
  // Lire et redfinir le module commun
  static const Anneau& module() { return mod; };
  static void module( const Anneau& m ) { mod= assopref(m); };

  // Lire et rduire le reprsentant modulo mod
  void reduire() { rep= eumod( rep, mod ); };
  const Anneau& representant() const { return rep; };

  // Constructeurs
  Quot( const Quot& a ) : rep( a.rep ) {};
  Quot( const Anneau& r=Anneau(0) ) : rep( eumod( r, mod ) ) {};

  // S'ajoutent ici d'autres mthodes encore  implmenter ...
};

// On dfinit ensuite la variable statique de la classe Quot<Anneau>
template <typename Anneau>
Anneau Quot<Anneau>::mod(0);

// Exemple d'utilisation
#include "integer.cc"
int main()
{
  Quot<Integer> a(11), b(12);
  cout << "a = " << a.representant() << " mod " << a.module() << endl;
  cout << "b = " << b.representant() << " mod " << b.module() << endl;
  Quot<Integer>::module(5);
  cout << "a = " << a.representant() << " mod " << a.module() << endl;
  cout << "b = " << b.representant() << " mod " << b.module() << endl;
  Quot<Integer> c= a+b;
  cout << "c = " << c.representant() << " mod " << c.module() << endl;
}
