//=======================================================================
// leibniz.cc : sommation de la srie alterne (-1)^(k+1) 1/k
// Copyright (C) 2006-2007 Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//
// Description :
// La srie alterne de terme gnral  (-1)^(k+1) 1/k  
// converge vers log(2) mais seulement trs lentement.
//=======================================================================
#include <iostream>
#include <cmath>
using namespace std;

int main()
{
  double somme1= 0, somme2= 0;
  for( int k= 1; k <= 1000000; ++k )
    if ( k%2 == 0 ) somme1-= 1.0/k; else somme1+= 1.0/k;
  for( int k= 1; k <= 1000000; k+=2 )
    somme2+= 1.0/k/(k+1);
 
  cout.precision(20);
  cout << "Leibniz1 : " << somme1 << endl
       << "Leibniz2 : " << somme2 << endl
       << "cmath    : " << log(2.0) << endl;
}
