//=======================================================================
// quadratique.cc : rsolution d'une quation quadratique
// Copyright (C) 2006-2007 Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//
// Description :
// Ce programme htif essaie de rsoudre une quation quadratique.
// Dans beaucoup de cas les rsultats ne sont pas satisfaisants.
//=======================================================================

#include <iostream>
#include <cmath> 
#include <complex>
using namespace std;

typedef float Flo;
// typedef complex<double> Flo;

bool quadsolve( const Flo& a, const Flo& b, const Flo& c, Flo& x1, Flo& x2 )
{
  Flo r= sqrt( b*b - Flo(4)*a*c ); // racine ? quelle racine ?
  x1= (-b+r) / (Flo(2)*a);         // on devrait tester si 2a != 0
  x2= (-b-r) / (Flo(2)*a);         // on devrait tester si 2a != 0
  return true;                     // pour signaler "ok, pas d'erreur"
}

int main()
{
  cout.precision(20);
  cout << "\nBonjour et bienvenue aux polynmes !" << endl
       << "Ce programme naf marche pour quelques polynmes," << endl
       << "mais il n'est pas au point pour des calculs dcliats." << endl
       << "(Essayez X^2+1e10X+1 par exemple.)" << endl;
  
  cout << "\nEntrez les coefficients a,b,c du polynme aX+bX+c svp :" << endl;
  Flo a,b,c;
  cout << "a = "; cin >> a;
  cout << "b = "; cin >> b;
  cout << "c = "; cin >> c;
  cout << "Le polynme " << a << "X + " << b << "X + " << c << endl;
  
  Flo x1,x2;
  quadsolve( a, b, c, x1, x2 );
  cout << "a pour racines x1 = " << x1 << " et x2 = " << x2 << endl;
  
  Flo bb= -a * ( x1 + x2 );
  Flo cc= a * x1 * x2;
  cout << "Vrification : a(X-x1)*(X-x2) = " 
       << a << "X + " << bb << "X + " << cc << endl;
}
