//=======================================================================
// quadratique.cc :  quations quadratiques en arithmtique d'intervalles
// Copyright (C) 2007 Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//
// Compilation :
// Compiler avec l'option -lgmpxx pour intgrer la bibliothque gmp. 
//
// Description :
// La classe Interval illustre comment implmenter, avec des outils 
// trs lmentaires, le calcul fiable sous forme d'intervalles.
// Nous utilisons ici la classe RReal faite maison pour contrler 
// explicitement le mode d'arrondi. 
//=======================================================================

#include "interval.cc"
using namespace Numeric;

//-----------------------------------------------------------------------
// La fonction main() gre la communication avec l'utilisateur
//-----------------------------------------------------------------------
int main()
{
  cout << "\nBienvenue  l'arithmtique des intervalles !\n" << endl;
  const Len decimales= 20;
  RReal::len( 3*decimales );
  cout.precision(decimales);
  
  Interval a,b,c;
  cout << "Entrez un polynme aX+bX+c  coefficients rels sous forme d'intervalles :" << endl;
  cout << "a = ";
  cin >> a;
  cout << "a = " << a << endl;
  
  cout << "b = ";
  cin >> b;
  cout << "b = " << b << endl;
  
  cout << "c = ";
  cin >> c;
  cout << "c = " << c << endl;
  
  Interval r= sqrt( sqr(b) - 4*a*c );
  Interval x1= (-b+r)/(2*a);
  Interval x2= (-b-r)/(2*a);

  cout << "Le polynme  aX + bX + c  a pour racines :" << endl
       << "x1 = " << x1 << endl << "x2 = " << x2 << endl;
  
  Interval bb= -a * ( x1 + x2 );
  Interval cc= a * x1 * x2;
  cout << "Vrification :  a(X-x1)*(X-x2) = aX + BX + C  avec" << endl
       << "B = " << bb << endl << "C = " << cc << endl;
  
  cout << "\nAu revoir et  bientt.\n" << endl;
}
