//=======================================================================
// iter2.cc : application de la mthode de Newton
// Copyright (C) 2005-2007 by Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
// 
// On se propose ici de calculer une valeur approche de l'unique
// solution relle de l'quation  x = cos(x)  via la mthode de Newton.
//=======================================================================

#include <iostream>
#include <cmath>
using namespace std;

//-----------------------------------------------------------------------
// Dfinir la fonction  tudier, puis sa drive
//-----------------------------------------------------------------------
double f0( double x )     // la fonction f  tudier
{ return cos(x)-x; }

double f1( double x )     // la drive f' de f
{ return -sin(x)-1; }

const double x  = 1.0;   // valeur initiale de l'itration

//-----------------------------------------------------------------------
// Dfinir la fonction  tudier, puis sa drive
//-----------------------------------------------------------------------
/*
double f0( double x )     // la fonction  tudier
{ return exp(x/3)-x; }

double f1( double x )     // la drive de f
{ return exp(x/3)/3-1; }

// const double x  = 1.8;   // valeur initiale de l'itration
const double x  = 4.5;   // valeur initiale de l'itration
*/

//-----------------------------------------------------------------------
// Lancer l'itration de Newton
//-----------------------------------------------------------------------
int main()
{
  cout.precision(16);
  cout.setf( ios::fixed );

  cout << "\nBonjour et bienvenue  la mthode de Newton !" << endl
       << "On cherche  approcher la solution de cos(x) = x" << endl
       << "par la mthode de Newton." << endl;

  // Dfinir puis afficher la valeur initiale
  double u= x;
  cout << "Valeur initiale:" << endl;
  cout.width(4);
  cout.unsetf( ios::showpos );
  cout << 0 << " : ";
  cout.setf( ios::showpos );
  cout << u << endl;

  // Afficher les valeurs de la suite itrative
  cout << "Itrations: " << endl;
  for( int n=1; n<=5; ++n )
    {
      u= u - f0(u)/f1(u);
      cout.width(4);
      cout.unsetf( ios::showpos );
      cout << n << " : ";
      cout.setf( ios::showpos );
      cout << u << endl;
    };
  
  cout << "Au revoir et  bientt.\n" << endl;
}
