//=======================================================================
// newton1669.cc : application de la mthode de Newton aux polynmes
// Copyright (C) 2005-2007 Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//=======================================================================

#include <iostream>  // entre-sortie via des flots 
#include <iomanip>   // manipulateurs pour formater l'affichage
#include <complex>   // nombres complexes gnriques
using namespace std;

//-----------------------------------------------------------------------
// Dfinir le type C des nombres machine  utiliser 
//-----------------------------------------------------------------------
typedef complex<double> C;

//-----------------------------------------------------------------------
// Dfinir le polynme  X^3-2X-5  puis sa drive  3X^2-2
//-----------------------------------------------------------------------
C p0( const C& x )
{ return ( x*x - 2.0 ) * x - 5.0 ; }

C p1( const C& x )
{ return 3.0*x*x - 2.0; }

//-----------------------------------------------------------------------
// Lancer l'itration de Newton
//-----------------------------------------------------------------------
int main()
{
  cout.precision(16);
  cout.setf( ios::fixed );

  cout << "\nBonjour et bienvenue  la mthode de Newton !" << endl
       << "On se propose de chercher des racines de X-2X-5." << endl
       << "Entre une valeur initiale svp : ";
  C x;
  cin >> x;

  // Afficher la valeur initiale
  cout.width(4);
  cout.unsetf( ios::showpos );
  cout << 0 << " : ";
  cout.setf( ios::showpos );
  cout << x << endl;

  // Afficher les valeurs de la suite itre
  for( int n=1; n<=20; ++n )
    {
      x= x - p0(x) / p1(x);
      cout.width(4);
      cout.unsetf( ios::showpos );
      cout << n << " : ";
      cout.setf( ios::showpos );
      cout << x << endl;
    };
  
  cout << "Au revoir et  bientt.\n" << endl;
}
